# libwaystub - uhhhhhhhhhh

There was a point in time when attempts at making firefox be compileable with only wayland support brought the issue with a hard runtime dependency on wayland libs even for X users. And that's why this, uh, thing, exists.

# Idea

If there are functions that we want to just omit in the C++ code, we can write stubs for these functions. That approach, surprisingly enough, worked. By simply writing functions that return `NULL` with the names of wayland library functions that firefox expects, we force firefox to believe that wayland libraries are either there and functional but wayland isn't running, or that the wayland library functions return errors in all cases (whichever it is). Despite the absurdity, the approach worked.

# Building

```
mkdir build
cd build
cmake ..
make
```
you should then have libwaystub.so in the build directory. Copy it to wherever you want to apply the stubs, and add the library to `LD_PRELOAD` before launching your application that you want to apply this stub for.

# Dependencies

`gdk`, a compiler and, preferrably, brain.

# License

This work is licensed under the MIT-0 license. 
